//+------------------------------------------------------------------+
//|                                                 Trend+Levels.mq4 |
//|                                        Copyright 2020, Vladradon |
//|                                                fxradon@gmail.com |
//+------------------------------------------------------------------+

#property strict
#property indicator_chart_window
#property indicator_buffers 7


extern ENUM_TIMEFRAMES    Timeframe=PERIOD_CURRENT;
extern int                PeriodMA=5;
extern ENUM_MA_METHOD     ModeMA=MODE_SMA;
extern ENUM_APPLIED_PRICE PriceMA=PRICE_CLOSE;
extern int                WidthMA=2;
extern color              ColorMA=clrRed;
extern int                ShiftLevel_1=100;
extern int                HourStartLevel_1=0;
extern int                HourStopLevel_1=4;
extern int                WidthLev_1=1;
extern color              ColorLev_1=clrYellow;
extern int                ShiftLevel_2=200;
extern int                HourStartLevel_2=0;
extern int                HourStopLevel_2=4;
extern int                WidthLev_2=1;
extern color              ColorLev_2=clrYellow;
extern int                ShiftLevel_3=300;
extern int                HourStartLevel_3=0;
extern int                HourStopLevel_3=4;
extern int                WidthLev_3=1;
extern color              ColorLev_3=clrYellow;
extern ENUM_LINE_STYLE    LevelsStyle=STYLE_DASHDOT;


double Buff[],LevUp1[],LevUp2[],LevUp3[],LevDn1[],LevDn2[],LevDn3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorBuffers(7);
//--- indicator buffers mapping
   SetIndexBuffer(0,Buff);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,WidthMA,ColorMA);
   
   SetIndexBuffer(1,LevUp1);
   SetIndexStyle(1,DRAW_LINE,LevelsStyle,WidthLev_1,ColorLev_1);
   
   SetIndexBuffer(2,LevUp2);
   SetIndexStyle(2,DRAW_LINE,LevelsStyle,WidthLev_2,ColorLev_2);
   
   SetIndexBuffer(3,LevUp3);
   SetIndexStyle(3,DRAW_LINE,LevelsStyle,WidthLev_3,ColorLev_3);
   
   SetIndexBuffer(4,LevDn1);
   SetIndexStyle(4,DRAW_LINE,LevelsStyle,WidthLev_1,ColorLev_1);
   
   SetIndexBuffer(5,LevDn2);
   SetIndexStyle(5,DRAW_LINE,LevelsStyle,WidthLev_2,ColorLev_2);
   
   SetIndexBuffer(6,LevDn3);
   SetIndexStyle(6,DRAW_LINE,LevelsStyle,WidthLev_3,ColorLev_3);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  if(rates_total<=PeriodMA) return(0);
  int limit=rates_total-prev_calculated;
//---
  if(prev_calculated>0) limit++;
  int Hours=0;
  for(int i=limit-1; i>=0; i--) 
    {
     Buff[i]=iMA(_Symbol,Timeframe,PeriodMA,0,ModeMA,PriceMA,i);
     Hours=TimeHour(Time[i]);
     
     if((HourStartLevel_1<HourStopLevel_1 && Hours>=HourStartLevel_1 && Hours<HourStopLevel_1) ||
        (HourStartLevel_1>HourStopLevel_1 && (Hours>=HourStartLevel_1 || Hours<HourStopLevel_1)))
        {LevUp1[i]=Buff[i]+ShiftLevel_1*_Point; LevDn1[i]=Buff[i]-ShiftLevel_1*_Point;}
     else {LevUp1[i]=EMPTY_VALUE; LevDn1[i]=EMPTY_VALUE;}
     
     if((HourStartLevel_2<HourStopLevel_2 && Hours>=HourStartLevel_2 && Hours<HourStopLevel_2) ||
        (HourStartLevel_2>HourStopLevel_2 && (Hours>=HourStartLevel_2 || Hours<HourStopLevel_2)))
        {LevUp2[i]=Buff[i]+ShiftLevel_2*_Point; LevDn2[i]=Buff[i]-ShiftLevel_2*_Point;}
     else {LevUp2[i]=EMPTY_VALUE; LevDn2[i]=EMPTY_VALUE;}
     
     if((HourStartLevel_3<HourStopLevel_3 && Hours>=HourStartLevel_3 && Hours<HourStopLevel_3) ||
        (HourStartLevel_3>HourStopLevel_3 && (Hours>=HourStartLevel_3 || Hours<HourStopLevel_3)))
        {LevUp3[i]=Buff[i]+ShiftLevel_3*_Point; LevDn3[i]=Buff[i]-ShiftLevel_3*_Point;}
     else {LevUp3[i]=EMPTY_VALUE; LevDn3[i]=EMPTY_VALUE;}
    }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
